#!/usr/bin/env python
# -*- coding: utf-8 -*-
from math import log

from collections import Counter


def shannon(observations):
    observations = map(tuple, observations)  # make it hashable
    counter = Counter(observations)
    total = len(observations)
    entropy = 0.0
    for count in counter.values():
        probability = (count * 1.0) / total
        entropy -= probability * log(probability, 2)
    model = counter
    return entropy, model


if __name__ == "__main__":
    obs = [
        [1, 2],
        [1, 2, 3],
        [2, 3],
        [1, 2],
        [1, 2],
        [1, 2, 3]
    ]
    print shannon(obs)
