#!/usr/bin/env python
# -*- coding: utf-8 -*-
import random


RANDOM_PROBABILITY = lambda: random.random()
FAIR_COIN_FLIP = lambda: random.choice([0, 1])
BIASED_COIN_FLIP = lambda bias: 1 if RANDOM_PROBABILITY() < bias else 0


def generate_with_cooccurrence(num_dimensions, num_observations, cooccurrence_probability, uniform_noise):
    assert num_dimensions > 1, "number of dimensions must be at least two"

    dimension_names = range(num_dimensions)
    observations = []
    for i in xrange(num_observations):
        observation = []
        for j in xrange(num_dimensions):
            if j == 0:
                observation.append(BIASED_COIN_FLIP(cooccurrence_probability))
            else:
                if observation[j - 1] == 1:
                    if RANDOM_PROBABILITY() < uniform_noise:
                        print 'here'
                        observation.append(0)
                    else:
                        observation.append(1)
                else:
                    observation.append(0)
        observation = [k for k in xrange(num_dimensions) if observation[k] == 1]
        observations.append(observation)

    return observations


def generate_with_dependence(num_dimensions, num_observations, dependence_probability, uniform_noise):
    assert num_dimensions > 1, "number of dimensions must be at least two"

    dimension_names = range(num_dimensions)
    observations = []
    for i in xrange(num_observations):
        observation = []
        for j in xrange(num_dimensions):
            if j == 0:
                observation.append(FAIR_COIN_FLIP())
            else:
                if observation[j - 1] == 1 and RANDOM_PROBABILITY() < dependence_probability:
                    if RANDOM_PROBABILITY() < uniform_noise:
                        observation.append(0)
                    else:
                        observation.append(1)
                else:
                    observation.append(0)
        observation = [k for k in xrange(num_dimensions) if observation[k]]
        observations.append(observation)

    return observations


if __name__ == "__main__":
    # print generate_with_dependence(3, 10, 0.9, 0.1)
    # print generate_with_dependence(5, 10, 0.9, 1.0)
    observations = generate_with_cooccurrence(4, 100, 0.5, 0.0)
    print observations
