#!/usr/bin/env python
# -*- coding: utf-8 -*-
import random
from collections import defaultdict


def generate_patterns(num_alphabets):
    patterns = []
    alphabets = range(num_alphabets)
    num_patterns = random.randint(20, 50)
    for i in xrange(num_patterns):
        pattern_length = random.randint(5, 10)
        pattern = random.sample(alphabets, pattern_length)
        patterns.append(pattern)
    return patterns


def inject_patterns(event_sequences, num_alphabets, len_sequence, debug):
    patterns = generate_patterns(num_alphabets)
    max_pattern_len = min(map(len, patterns))
    pattern_freq = defaultdict(int)
    mark = 0
    while mark <= (len_sequence - max_pattern_len):
        if random.random() <= 0.5:
            pattern = random.choice(patterns)
            len_pattern = len(pattern)
            pattern_freq[tuple(pattern)] += 1
            for i in xrange(len(event_sequences)):
                event_sequences[i][mark:mark + len_pattern] = pattern
            mark += len_pattern
        else:
            mark += 1

    if debug:
        for pattern, freq in pattern_freq.iteritems():
            print pattern, " → ", freq


def generate_event_sequence(num_alphabets, len_sequence):
    alphabets = range(num_alphabets)
    return [random.choice(alphabets) for i in xrange(len_sequence)]


def generate_event_sequences(num_variables, num_alphabets, len_sequence, debug=False):
    assert len_sequence >= 3000
    assert num_alphabets >= 20
    event_sequences = [generate_event_sequence(
        num_alphabets, len_sequence) for i in xrange(num_variables)]
    inject_patterns(event_sequences, num_alphabets, len_sequence, debug)
    return event_sequences


if __name__ == "__main__":
    generate_event_sequences(2, 20, 5000)
    # import matplotlib.pyplot as plt
    # plt.plot(event_sequences[0])
    # plt.show()
