
#!/usr/bin/env python
# -*- coding: utf-8 -*-
from store import Store


class SequenceStore(Store):
    # an observation = a dimension

    def __init__(self, observations):
        super(SequenceStore, self).__init__()
        self.update_observations(observations)

    def project(self, dimension_names, remap=True):
        # dimension name starts with zero (0)
        for dim_name in dimension_names:
            assert dim_name in self.dimension_names, "Invalid dimension name `%d`." % dim_name
        return [self.dimensions[dname] for dname in dimension_names]

    def update_observations(self, observations):
        num_dimensions = len(observations)
        self.dimension_names = range(num_dimensions)
        self.dimensions = observations

    def swap_randomise(self):
        raise NotImplementedError(
            "Swap randomisation is not available for sequential data.")


if __name__ == "__main__":
    s = SequenceStore([[1, 2, 2, 3, 3, 2, 2, 1, 2, 1], [
                          2, 2, 3, 4, 4, 5, 5], [9, 0, 0, 9, 0, 0, 9]])
    print s.project([0, 1])
    # print s.project([4])
